Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/searchpanel/DefaultSearchPanel.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/searchpanel/DefaultSearchPanel.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/searchpanel/DefaultSearchPanel.java	(revision 44259)
@@ -0,0 +1,425 @@
+package org.gvsig.fmap.dal.swing.impl.searchpanel;
+
+import java.awt.Dimension;
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
+import java.net.URL;
+import java.util.ArrayList;
+import java.util.List;
+import javax.swing.ImageIcon;
+import javax.swing.JComponent;
+import javax.swing.event.ListSelectionEvent;
+import javax.swing.event.ListSelectionListener;
+import javax.swing.table.AbstractTableModel;
+import org.apache.commons.io.FilenameUtils;
+import org.gvsig.expressionevaluator.Expression;
+import org.gvsig.expressionevaluator.ExpressionBuilder;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_AND;
+import static org.gvsig.expressionevaluator.ExpressionBuilder.OPERATOR_OR;
+import org.gvsig.expressionevaluator.ExpressionUtils;
+import org.gvsig.expressionevaluator.swing.ExpressionEvaluatorSwingLocator;
+import org.gvsig.expressionevaluator.swing.ExpressionEvaluatorSwingManager;
+import org.gvsig.expressionevaluator.swing.ExpressionPickerController;
+import org.gvsig.featureform.swing.JFeaturesForm;
+import org.gvsig.fmap.dal.exception.DataException;
+import org.gvsig.fmap.dal.feature.Feature;
+import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
+import org.gvsig.fmap.dal.feature.FeatureQuery;
+import org.gvsig.fmap.dal.feature.FeatureStore;
+import org.gvsig.fmap.dal.feature.FeatureType;
+import org.gvsig.fmap.dal.swing.DALSwingLocator;
+import org.gvsig.fmap.dal.swing.DataSwingManager;
+import org.gvsig.fmap.dal.swing.searchpanel.FeatureStoreSearchPanel;
+import org.gvsig.tools.dataTypes.DataType;
+import org.gvsig.tools.swing.api.ActionListenerSupport;
+import org.gvsig.tools.swing.api.ToolsSwingLocator;
+import org.gvsig.tools.swing.api.windowmanager.WindowManager;
+import org.gvsig.tools.swing.icontheme.IconTheme;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+@SuppressWarnings("UseSpecificCatch")
+public class DefaultSearchPanel
+        extends DefaultSearchPanelView
+        implements FeatureStoreSearchPanel {
+
+    private static final Logger LOGGER = LoggerFactory.getLogger(DefaultSearchPanel.class);
+    private boolean showFormSingleElement;
+    private Expression currentSearch;
+
+    private class FeaturesTableModel extends AbstractTableModel {
+
+        private final List<Feature> features;
+        private final List<String> columnNames;
+        private final FeatureType featureType;
+
+        public FeaturesTableModel(FeatureType featureType, List<String> columnNames, List<Feature> features) {
+            this.features = features;
+            this.featureType = featureType;
+            if (columnNames == null || columnNames.isEmpty()) {
+                this.columnNames = new ArrayList<>();
+                List<FeatureAttributeDescriptor> attributos = SearchUtils.getOrderedAttributes(
+                        featureType,
+                        SearchUtils.BASIC_TYPES_FILTER,
+                        SearchUtils.STR_INT_LONG_LABEL_ORDER, 
+                        12
+                );
+                for (FeatureAttributeDescriptor attrdesc : attributos) {
+                    this.columnNames.add(attrdesc.getName());
+                }
+            } else {
+                this.columnNames = columnNames;
+            }
+        }
+
+        public List<Feature> getFeatures() {
+            return this.features;
+        }
+
+        @Override
+        public int getRowCount() {
+            if (this.features == null) {
+                return 0;
+            }
+            return this.features.size();
+        }
+
+        @Override
+        public int getColumnCount() {
+            return this.columnNames.size();
+        }
+
+        @Override
+        public String getColumnName(int columnIndex) {
+            String attrName = this.columnNames.get(columnIndex);
+            if (this.featureType == null) {
+                return attrName;
+            }
+            FeatureAttributeDescriptor attrdesc = this.featureType.getAttributeDescriptor(attrName);
+            if (attrdesc == null) {
+                return "C" + columnIndex;
+            }
+            return attrdesc.getLabel();
+        }
+
+        @Override
+        public Class<?> getColumnClass(int columnIndex) {
+            if (this.featureType == null) {
+                return String.class;
+            }
+            String attrName = this.columnNames.get(columnIndex);
+            FeatureAttributeDescriptor attrdesc = this.featureType.getAttributeDescriptor(attrName);
+            if (attrdesc == null) {
+                return String.class;
+            }
+            return attrdesc.getDataType().getDefaultClass();
+        }
+
+        @Override
+        public boolean isCellEditable(int rowIndex, int columnIndex) {
+            return false;
+        }
+
+        @Override
+        public Object getValueAt(int rowIndex, int columnIndex) {
+            if (this.features == null) {
+                return null;
+            }
+            Feature feature = this.features.get(rowIndex);
+            String attrName = this.columnNames.get(columnIndex);
+            try {
+                return feature.get(attrName);
+            } catch (Throwable th) {
+                return null;
+            }
+        }
+
+        @Override
+        public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
+
+        }
+    }
+
+    private final FeatureStore store;
+    private final ActionListenerSupport acctionListeners;
+    private final List<SearchFieldController> searchFields;
+    private ExpressionPickerController advancedExpression;
+
+    public DefaultSearchPanel(FeatureStore store) {
+        this.store = store;
+        this.acctionListeners = ToolsSwingLocator.getToolsSwingManager().createActionListenerSupport();
+        this.searchFields = new ArrayList<>();
+        this.initComponents();
+    }
+
+    @Override
+    public JComponent asJComponent() {
+        return this;
+    }
+
+    @Override
+    public void addActionListener(ActionListener listener) {
+        this.acctionListeners.addActionListener(listener);
+    }
+
+    @Override
+    public ActionListener[] getActionListeners() {
+        return this.acctionListeners.getActionListeners();
+    }
+
+    @Override
+    public void removeActionListener(ActionListener listener) {
+        this.acctionListeners.removeActionListener(listener);
+    }
+
+    @Override
+    public void removeAllActionListener() {
+        this.acctionListeners.removeAllActionListener();
+    }
+
+    @Override
+    public void fireActionEvent(ActionEvent event) {
+        this.acctionListeners.fireActionEvent(event);
+    }
+
+    @Override
+    public boolean hasActionListeners() {
+        return this.acctionListeners.hasActionListeners();
+    }
+
+    private void initComponents() {
+        SearchFieldController controller = new SearchFieldController(
+                store,
+                lblField1,
+                lblExtraFields1,
+                lblRelationalOperator1,
+                cboValue1,
+                lblLogicalOperators1
+        );
+        this.searchFields.add(controller);
+        controller = new SearchFieldController(
+                store,
+                lblField2,
+                lblExtraFields2,
+                lblRelationalOperator2,
+                cboValue2,
+                lblLogicalOperators2
+        );
+        this.searchFields.add(controller);
+        controller = new SearchFieldController(
+                store,
+                lblField3,
+                lblExtraFields3,
+                lblRelationalOperator3,
+                cboValue3,
+                lblLogicalOperators3
+        );
+        this.searchFields.add(controller);
+        controller = new SearchFieldController(
+                store,
+                lblField4,
+                lblExtraFields4,
+                lblRelationalOperator4,
+                cboValue4,
+                null
+        );
+        this.searchFields.add(controller);
+
+        List<FeatureAttributeDescriptor> orderedAttributes = SearchUtils.getOrderedAttributes(
+                this.store, 
+                SearchUtils.BASIC_TYPES_FILTER,
+                SearchUtils.STR_INT_LONG_LABEL_ORDER,
+                5
+        );
+        int n = 0;
+        for (SearchFieldController searchField : searchFields) {
+            searchField.setAttribute(orderedAttributes.get(n++).getName());
+        }
+
+        ExpressionEvaluatorSwingManager expressionSwingManager = ExpressionEvaluatorSwingLocator.getManager();
+        this.advancedExpression = expressionSwingManager.createExpressionPickerController(txtAdvancedExpression, btnAdvancedExpression);
+
+        this.btnSearch.addActionListener(new ActionListener() {
+            @Override
+            public void actionPerformed(ActionEvent e) {
+                doSearch();
+            }
+        });
+
+        this.btnShowForm.addActionListener(new ActionListener() {
+            @Override
+            public void actionPerformed(ActionEvent e) {
+                doShowForm();
+            }
+        });
+        try {
+            this.showFormSingleElement = true;
+            FeatureAttributeDescriptor[] pks = this.store.getDefaultFeatureType().getPrimaryKey();
+            if (pks == null || pks.length < 1) {
+                this.showFormSingleElement = false;
+            }
+        } catch (Exception ex) {
+        }
+        this.btnShowForm.setEnabled(true);
+        
+        this.tblResults.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
+            @Override
+            public void valueChanged(ListSelectionEvent e) {
+                if( e.getValueIsAdjusting() ) {
+                    return;
+                }
+                if( tblResults.getSelectedRowCount()==0 ) {
+                    btnShowForm.setEnabled(true);
+                    return;
+                }
+                btnShowForm.setEnabled(showFormSingleElement);
+            }
+        });
+        this.btnClear.addActionListener(new ActionListener() {
+            @Override
+            public void actionPerformed(ActionEvent e) {
+                clear();
+            }
+        });
+        this.setPreferredSize(new Dimension(700, 450));
+
+        doSearch(null);
+    }
+
+    public void clear() {
+        for (SearchFieldController searchField : searchFields) {
+            searchField.clear();
+        }        
+        this.advancedExpression.set(null);
+    }
+    
+    private void doSearch() {
+        int searchMode = this.tabSearchMode.getSelectedIndex();
+        if (searchMode == 1) { // Avanzada
+            Expression filter = this.advancedExpression.get();
+            if (ExpressionUtils.isPhraseEmpty(filter)) {
+                return;
+            }
+            doSearch(filter);
+            return;
+        }
+        
+        ExpressionBuilder builder = ExpressionUtils.createExpressionBuilder();
+        String relational = OPERATOR_OR;
+        for (SearchFieldController searchField : searchFields) {
+            if( searchField.getAttribute()!=null && searchField.getValue()!=null ) {
+                ExpressionBuilder.BinaryOperator cond = builder.binaryOperator(
+                        searchField.getRelationalOperator(),
+                        searchField.isAttributeAnExpression()?
+                                builder.custom(searchField.getAttribute()):
+                                builder.column(searchField.getAttribute()),
+                        builder.constant(searchField.getValue())                
+                );
+                if( relational.equals(OPERATOR_AND) ) {
+                    builder.and(cond);
+                } else {
+                    builder.or(cond);
+                }
+                relational = searchField.getLogicalOperator();
+            }
+        }
+        if( builder.isEmpty() ) {
+            doSearch(null);
+            return;
+        }
+        this.txtAdvancedExpression.setText(builder.toString());
+        doSearch(ExpressionUtils.createExpression(builder.toString()));
+    }
+
+    private void doSearch(Expression exp) {
+        FeaturesTableModel model;
+        try {
+            List<Feature> features;
+            if (exp == null) {
+                features = this.store.getFeatures();
+            } else {
+                features = this.store.getFeatures(exp);
+            }
+            this.currentSearch = exp;
+            model = new FeaturesTableModel(
+                    this.store.getDefaultFeatureType(),
+                    null,
+                    features
+            );
+            this.tblResults.setModel(model);
+            this.lblMsg.setText(String.format("%d elementos", features.size()));
+        } catch (DataException ex) {
+
+        }
+    }
+
+    private void doShowForm() {
+        try {
+            this.btnShowForm.setEnabled(false);
+            DataSwingManager dataSwingManager = DALSwingLocator.getSwingManager();
+
+            Expression filter;
+            int selectedRow = this.tblResults.getSelectedRow();
+            if( selectedRow<0 ) {
+                filter = this.currentSearch;
+            } else {
+                List<Feature> features = ((FeaturesTableModel) this.tblResults.getModel()).getFeatures();
+                Feature feature = features.get(selectedRow);
+
+                ExpressionBuilder builder = ExpressionUtils.createExpressionBuilder();
+                FeatureType ftype = this.store.getDefaultFeatureType();
+                for (FeatureAttributeDescriptor attrdesc : ftype.getPrimaryKey()) {
+                    builder.and(
+                            builder.eq(
+                                    builder.column(attrdesc.getName()),
+                                    builder.constant(feature.get(attrdesc.getName()))
+                            )
+                    );
+                }
+                filter = ExpressionUtils.createExpression(builder.toString());
+            }
+            FeatureQuery query = store.createFeatureQuery();
+            query.setFilter(filter);
+            query.retrievesAllAttributes();
+            JFeaturesForm form = dataSwingManager.createJFeaturesForm(store);
+            form.setQuery(query);
+            form.showForm(WindowManager.MODE.WINDOW);
+
+        } catch (Exception ex) {
+            LOGGER.warn("Can't show form", ex);
+        } finally {
+            this.btnShowForm.setEnabled(true);
+        }
+    }
+
+    @Override
+    public ImageIcon loadImage(String imageName) {
+        String name = FilenameUtils.getBaseName(imageName);
+        IconTheme theme = ToolsSwingLocator.getIconThemeManager().getDefault();
+        if (theme.exists(name)) {
+            return theme.get(name);
+        }
+        URL url = this.getClass().getResource(name + ".png");
+        if (url == null) {
+            return null;
+        }
+        return new ImageIcon(url);
+    }
+
+    public static void selfRegister() {
+        String[][] iconNames = new String[][] {
+            new String[] { "dalswing", "featurestore-search-attribute-selector" }
+        };
+        IconTheme theme = ToolsSwingLocator.getIconThemeManager().getCurrent();
+        for (String[] icon : iconNames) {
+            URL url = DefaultSearchPanel.class.getResource(icon[1]+".png");
+            theme.registerDefault("DALSwing", icon[0], icon[1], null, url);
+        }
+        
+        
+    }
+}
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/searchpanel/RecentUsedsAttributesImpl.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/searchpanel/RecentUsedsAttributesImpl.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.swing/org.gvsig.fmap.dal.swing.impl/src/main/java/org/gvsig/fmap/dal/swing/impl/searchpanel/RecentUsedsAttributesImpl.java	(revision 44259)
@@ -0,0 +1,65 @@
+package org.gvsig.fmap.dal.swing.impl.searchpanel;
+
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.Collections;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+import org.apache.commons.collections4.queue.CircularFifoQueue;
+import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
+import org.gvsig.fmap.dal.feature.FeatureStore;
+import org.gvsig.fmap.dal.feature.FeatureType;
+
+/**
+ *
+ * @author jjdelcerro
+ */
+public class RecentUsedsAttributesImpl {
+
+    private final Map<String,CircularFifoQueue<String>> recentsForStore;
+    
+    public RecentUsedsAttributesImpl() {
+        this.recentsForStore = new HashMap<>();
+    }
+    
+    public Collection<String> getNames(FeatureType featureType) {
+        FeatureStore store = featureType.getStore();
+        CircularFifoQueue<String> recents = this.recentsForStore.get(store.getFullName());
+        if( recents==null ) {
+            return Collections.EMPTY_LIST;
+        }
+        return recents;
+    }
+    
+    public Collection<FeatureAttributeDescriptor> getAttributes(FeatureType featureType) {
+        List<FeatureAttributeDescriptor> r = new ArrayList<>();
+        for (String name : this.getNames(featureType)) {
+            r.add(featureType.getAttributeDescriptor(name));
+        }
+        return r;
+    }
+
+    public void add(FeatureAttributeDescriptor attribute) {
+        this.add(attribute.getFeatureType(), attribute.getName());
+    }
+    
+    public void add(FeatureType featureType, FeatureAttributeDescriptor attribute) {
+        this.add(featureType, attribute.getName());
+    }
+    
+    public void add(FeatureType featureType, String name) {
+        String storeFullName = featureType.getStore().getFullName();
+        CircularFifoQueue<String> recents = this.recentsForStore.get(storeFullName);
+        if( recents==null ) {
+            recents = new CircularFifoQueue(this.getMaxSize());
+            this.recentsForStore.put(storeFullName, recents);
+        }
+        recents.remove(name);
+        recents.add(name);
+    }
+
+    public int getMaxSize() {
+        return 6;
+    }
+}
